/***************************************************************************/
/* 		This code is part of WWW grabber called pavuk		   */
/*		Copyright (c) 1997 - 2001 Stefan Ondrejicka		   */
/*		(ondrej@idata.sk)					   */
/*		Distributed under GPL 2 or later			   */
/***************************************************************************/

#ifndef _myssl_h_
#define _myssl_h_

#ifdef USE_SSL

#include "doc.h"
#include "bufio.h"

#ifdef OPENSSL
#include <openssl/rsa.h>
#include <openssl/crypto.h>
#include <openssl/x509.h>
#include <openssl/pem.h>
#include <openssl/ssl.h>
#include <openssl/err.h>
#include <openssl/md5.h>
#include <openssl/rand.h>
#else
#include <rsa.h>
#include <crypto.h>
#include <x509.h>
#include <pem.h>
#include <ssl.h>
#include <err.h>
#include <md5.h>
#include <rand.h>
#endif

extern void my_ssl_init(void);
extern int my_ssl_do_connect(doc *, bufio *, SSL **, SSL_CTX **, SSL_METHOD **, BIO **, SSL *);
extern int my_ssl_read(SSL *, char *, int);
extern int my_ssl_write(SSL *, char *, int);

typedef struct {
	SSL		*ssl_con;
	SSL_CTX		*ssl_ctx;
	SSL_METHOD	*ssl_method;
} ssl_connection;

#endif

#endif

